<template>
    <div class="p-relative page-view-wrapper">
        <component :is="currentView">
            <!-- component changes when vm.currentView changes! -->
        </component>
        <div class="white-overlay z-p3 shad" v-if="loading">
            <v-progress-circular indeterminate :size="50" color="primary"></v-progress-circular>
        </div>
    </div>
</template>

<script>
    import axios from './../plugins/axios';
    import store from './../store';
    import { mapGetters } from 'vuex';

    const CancelToken = axios.CancelToken;
    let source = null;

    function pageResolver(to, resolve, reject) {
        const url = typeof to === 'string' ? to : to.path;

        if (!url) {
            return;
        }

        if (source) {
            source.cancel('Page loading has been canceled.');
        }

        source = CancelToken.source();

        window.scrollTo(0, 0);

        store.commit('page/loading', true);

        axios.get(url, {
            cancelToken: source.token,
            responseType: 'text'
        }).then(response => {
            resolve(new PageComponent('<div class="page-view">' + response.data + '</div>', response.headers['model-data-url']));
            store.commit('page/loading', false);
        }).catch(e => {
            if (!axios.isCancel(e)) {
                store.commit('page/loading', false);
            }
            if (axios.isCancel(e)) {
                //console.log('Request canceled', thrown.message);
            } else if (e.response) {
                resolve({
                    template: `<v-alert class="mt-0" color="error" icon="warning" value="true">Error ${e.response.status}. ${e.response.statusText}</v-alert>`
                });
            } else {
                reject(e);
            }
        });
    }

    class PageComponent {
        constructor(template, modelDataUrl) {
            this.template = template;
            this._source = null;

            this.created = function () {
                if (modelDataUrl) {
                    this._source = axios.CancelToken.source();

                    axios.get(modelDataUrl, {
                        cancelToken: this._source.token,
                        headers: {
                            'Accept': 'application/json'
                        },
                        responseType: 'json'
                    }).then(response => {
                        if (response.data) {
                            this.model = Object.assign({}, this.model, response.data);
                        }
                    }).catch(_ => null);
                }
            };

            this.mounted = function() {
                const dataGrid = this.$refs.dataGrid;
                if (typeof dataGrid !== 'undefined') {
                    this.dataGrid = dataGrid;
                }
            };

            this.destroyed = function() {
                if (this._source) {
                    this._source.cancel();
                }
            };

            this.data = () => ({
                dataGrid: {},
                model: {}
            });

            this.computed = {
                ...mapGetters({
                    'errors': 'form/errors'
                })
            }
        }
    }

    export default {
        data: () => ({
            currentView: null,
        }),

        computed: {
          loading() {
              return store.state.page.loading;
          }
        },

        mounted: function() {

        },

        beforeRouteEnter(to, from, next) {
            next(v => {
                v.currentView = (resolve, reject) => pageResolver(to, resolve, reject);
            });
        },

        beforeRouteUpdate(to, from, next) {
            this.currentView = (resolve, reject) => pageResolver(to, resolve, reject);
            next();
        },

        beforeRouteLeave(to, from, next) {
            if (source) {
                source.cancel();
            }
            next();
        }
    }
</script>
